import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;

public class ROT13  {
    String cyphered;
    int diff;

    ROT13(Character cs, Character cf) {
        this.diff = Math.abs(cs - cf);
    }

    ROT13() {
        this.diff = 13;
    }


    public String crypt(String text) throws UnsupportedOperationException {
        StringBuffer answer = new StringBuffer();

        for(int i = 0; i < text.length(); i++){
            if (!Character.isLetter(text.charAt(i))) {
                answer.append(text.charAt(i));
            } else if (Character.isUpperCase(text.charAt(i))) {
                char ch = (char) (((int) text.charAt(i) + diff - 65) % 26 + 65);
                answer.append(ch);
            } else {
                char ch = (char) (((int) text.charAt(i) + diff - 97) % 26 + 97);
                answer.append(ch);
            }
        }

        return answer.toString();
    }

    public String encrypt(String text) {
        return crypt(text);
    }

    public String decrypt(String text) {
        return crypt(text);
    }

    public String rotate(String s, Character c) {
        int difference = (int) c - 65;
        int i = difference % s.length();
        return s.substring(i) + s.substring(0,i);
    }

    public String fileString (File filePath) throws IOException {
        return new String(Files.readAllBytes(Paths.get(String.valueOf(filePath))));
    }

    public File newFile(String original, String newFileName) {
        File newFile = null;
        try {
            newFile = new File(newFileName);
            FileWriter fileWriter = new FileWriter(newFile);
            fileWriter.write(encrypt(fileString(new File(original))));
            fileWriter.flush();
            fileWriter.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return newFile;
    }

}
